%global __strip %{_mingw32_strip}
%global __objdump %{_mingw32_objdump}
%define __debug_install_post %{_mingw32_debug_install_post}

# first two digits of version
%define release_version %(echo %{version} | awk -F. '{print $1"."$2}')

Name:		mingw32-libsoup
Version:	2.36.1
Release:	1%{?dist}
Summary:	MinGW library for HTTP and XML-RPC functionality

License:	LGPLv2
Group:		Development/Libraries
URL:		http://live.gnome.org/LibSoup
Source0:	http://download.gnome.org/sources/libsoup/%{release_version}/libsoup-%{version}.tar.xz

BuildArch:	noarch

BuildRequires:	mingw32-filesystem
BuildRequires:	mingw32-gcc
BuildRequires:	mingw32-binutils
BuildRequires:	mingw32-glib2
BuildRequires:	mingw32-libxml2
BuildRequires:	mingw32-sqlite

Requires:	pkgconfig

Patch0:		libsoup-workaround-gnome-bug-595176.patch


%description
Libsoup is an HTTP library implementation in C. It was originally part
of a SOAP (Simple Object Access Protocol) implementation called Soup, but
the SOAP and non-SOAP parts have now been split into separate packages.
 
libsoup uses the Glib main loop and is designed to work well with GTK
applications. This enables GNOME applications to access HTTP servers
on the network in a completely asynchronous fashion, very similar to
the Gtk+ programming model (a synchronous operation mode is also
supported for those who want it).

This is the MinGW build of Libsoup


%package static
Summary:	Static version of the MinGW Windows Libsoup library
Requires:	%{name} = %{version}-%{release}
Group:		Development/Libraries

%description static
Static version of the MinGW Windows Libsoup library.


%{?_mingw32_debug_package}


%prep
%setup -q -n libsoup-%{version}
%patch0 -p0


%build
# Libsoup can't build static and shared libraries in one go, so we build the package twice here
mkdir build_static
pushd build_static
	%{_mingw32_configure}		\
		--without-apache-httpd	\
		--enable-static		\
		--disable-shared	\
		--with-gnome		\
		CFLAGS="$CFLAGS -DGLIB_STATIC_COMPILATION -DGOBJECT_STATIC_COMPILATION -DLIBXML_STATIC"
	make %{?_smp_mflags}
popd

mkdir build_shared
pushd build_shared
	%{_mingw32_configure}		\
		--without-apache-httpd	\
		--disable-static	\
		--enable-shared		\
		--with-gnome
	make %{?_smp_mflags}
popd


%install
# First install all the files belonging to the shared build
make -C build_shared DESTDIR=$RPM_BUILD_ROOT install

# Install all the files from the static build in a seperate folder
# and move the static libraries to the right location
make -C build_static DESTDIR=$RPM_BUILD_ROOT/build_static install
mv $RPM_BUILD_ROOT/build_static%{_mingw32_libdir}/*.a $RPM_BUILD_ROOT%{_mingw32_libdir}

# Manually merge the libtool files
sed -i s/"old_library=''"/"old_library='libsoup-2.4.a'"/ $RPM_BUILD_ROOT%{_mingw32_libdir}/libsoup-2.4.la

# Drop the folder which was temporary used for installing the static bits
rm -rf $RPM_BUILD_ROOT/build_static

# Strip all the GTK-Doc
rm -rf $RPM_BUILD_ROOT%{_mingw32_datadir}/gtk-doc


%files 
%doc COPYING
%{_mingw32_bindir}/libsoup-2.4-1.dll
%{_mingw32_bindir}/libsoup-gnome-2.4-1.dll
%{_mingw32_includedir}/libsoup-2.4
%{_mingw32_includedir}/libsoup-gnome-2.4
%{_mingw32_libdir}/libsoup-2.4.dll.a
%{_mingw32_libdir}/libsoup-2.4.la
%{_mingw32_libdir}/libsoup-gnome-2.4.dll.a
%{_mingw32_libdir}/libsoup-gnome-2.4.la
%{_mingw32_libdir}/pkgconfig/libsoup-2.4.pc
%{_mingw32_libdir}/pkgconfig/libsoup-gnome-2.4.pc

%files static
%{_mingw32_libdir}/libsoup-2.4.a
%{_mingw32_libdir}/libsoup-gnome-2.4.a


%changelog
* Tue Oct 18 2011 Kalev Lember <kalevlember@gmail.com> - 2.36.1-1
- Update to 2.36.1

* Sun Oct 02 2011 Kalev Lember <kalevlember@gmail.com> - 2.36.0-1
- Update to 2.36.0
- Spec cleanup for recent rpmbuild

* Thu Jul 07 2011 Kalev Lember <kalevlember@gmail.com> - 2.34.1-2
- Rebuilt against win-iconv

* Wed Apr 27 2011 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.34.1-1
- Update to 2.34.1
- Build with --with-gnome
- Dropped the BR: mingw32-gnutls as support for TLS connections has
  moved to glib-networking

* Sun Apr 24 2011 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.34.0-1
- Update to 2.34.0

* Fri Apr 22 2011 Kalev Lember <kalev@smartlink.ee> - 2.32.0-3
- Rebuilt for pseudo-reloc version mismatch (#698827)

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.32.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sun Nov  7 2010 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.32.0-1
- Update to 2.32.0

* Fri Nov 20 2009 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.28.1-1
- Update to 2.28.1

* Sat Sep 19 2009 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.27.92-2
- Rebuild because of broken mingw32-gcc/mingw32-binutils
- Added a patch to workaround GNOME BZ #595176

* Thu Sep 10 2009 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.27.92-1
- Update to 2.27.92
- Dropped the workaround for GNOME BZ #593845

* Tue Sep  1 2009 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.27.91-1
- Update to 2.27.91

* Thu Aug 13 2009 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.27.90-1
- Update to 2.27.90
- Automatically generate debuginfo subpackage
- Added BR: mingw32-gnutls for SSL support

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.27.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Jun 10 2009 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.27.1-1
- Update to 2.27.1

* Fri May 22 2009 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.26.1-2
- Fixed license typo
- Use %%global instead of %%define
- Fixed mixed-use-of-spaces-and-tabs rpmlint warning

* Sat May  9 2009 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.26.1-1
- Update to 2.26.1

* Fri Apr  3 2009 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.26.0-2
- Added -static subpackage

* Fri Mar 20 2009 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.26.0-1
- Update to 2.26.0

* Sat Feb 13 2009 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.25.5-1
- Initial release

